#include <libnova.h>
#include <curses.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <math.h>
#include "grapher.h"
#include "moonphase.h"
void usage(char * name)
{    
 
    printf(" Usage: %s [-g longitude] [-l latitude] [-u delay]\n",name);
    printf(" -g: longitude (degrees 0.0-90.0 Negative East of Greenwinch, positive West of Greenwinch)\n");
    printf(" -l: latitude  (degrees 0.0-180.0)\n");
    printf(" -v: Print version information and exit\n");
    printf(" -u: delay (0 - 10, default 4): Screen update delay\n\n");
}






void version(char * name)
{printf("%s version 1.0 by mulo (mulo@makemebad.net) www: http://makemebad.net/geek/codes/\n",name);}


void finish(int sigage) 
{
    curs_set(1);
    clear();
    refresh();
    resetty();
    endwin();
    exit(0);
}


int calculate (int update,double latitude,double longitude) {
double julian,light,dist,phase,age;
struct ln_lnlat_posn observer;
struct ln_rst_time rst;
struct ln_date date1,date2,date3;
time_t tempo;
struct tm * tempostruct;
const char * fmt="%Y";
const char * fmt2="%d";
size_t maxsize=100;
char giorno[maxsize];
char anno[maxsize];
int row,cols;


memset(&rst, 0, sizeof(rst));
memset(&date1, 0, sizeof(date1));
memset(&date2, 0, sizeof(date2));
memset(&date3, 0, sizeof(date3));

while (1) {
julian=get_julian_from_sys();
age=moonphase();


if ( (latitude != 0) || (longitude != 0 ) ) {
observer.lng=latitude;
observer.lat=longitude;
} else {observer.lng=45.12;observer.lat=8.42;}
light=100*get_lunar_disk(julian);
dist=get_lunar_earth_dist(julian);
get_lunar_rst(julian,&observer,&rst);
get_date(rst.rise,&date1);
get_date(rst.set,&date2);
get_date(julian,&date3);
getmaxyx(stdscr,row,cols);
grapher(dist,row,date1,date2,date3,age,light);
napms(update * 1000);
refresh();
}




}


int main (int argc, char ** argv) {
int row,cols,optchr,update=1;
double latitude=0,longitude=0;

 signal(SIGINT, finish);
 while ((optchr = getopt(argc, argv, "vhu:l:g:")) != EOF) 
{

	switch (optchr) {
	case 'h':
    	usage(argv[0]);
    	exit(0);
	case 'v':
    	version(argv[0]);    
    	exit(0);
	case 'u':
        update = atoi(optarg);
        break;
        case 'l':
        latitude = atoi(optarg);
        break; 
        case 'g':
        longitude = atoi(optarg);    
        break;

        	         	}
}

  initscr();
  savetty();
  nonl();
  cbreak();
  noecho(); 
  getmaxyx(stdscr,row,cols);
  leaveok(stdscr, TRUE);
  curs_set(0);
  calculate(update,latitude,longitude);



					}

